##
##  node-java.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2019 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_java      0.12.0
%define       V_java_snap 20191119

#   package information
Name:         node-java
Summary:      Node Bindings to Java
URL:          https://github.com/joeferner/node-java
Vendor:       Near Infinity Corporation
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      MIT
Version:      %{V_java}
Release:      20191119

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/node-java/node-java-%{V_java}-%{V_java_snap}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, gcc, gcc::with_cxx = yes, npm
PreReq:       OpenPKG, openpkg >= 20160101
BuildPreReq:  node, java, JAVA-JDK
PreReq:       node, java, JAVA-JDK

%description
    This is a Node.js binding to Java.

%track
    prog node-java:release = {
        version   = %{V_java}
        url       = https://github.com/joeferner/node-java/releases
        regex     = v(__VER__)\.tar\.gz
    }
    prog node-java:snapshot = {
        version   = %{V_java}-%{V_java_snap}
        url       = http://download.openpkg.org/components/versioned/node-java/
        regex     = node-java-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -c

%build
    #   build native parts
    (   cd node_modules/java
        export JAVA_PLATFORM="sun-jdk"
        eval `%{l_prefix}/bin/java-toolkit -e`
        npm run install
    ) || exit $?

    #   prune source tree
    find . -name test -type d -print | xargs rm -rf
    find . -name example -type d -print | xargs rm -rf
    find . -name examples -type d -print | xargs rm -rf
    find . -name ChangeLog -type f -print | xargs rm -f
    find . -name CHANGELOG.md -type f -print | xargs rm -f
    find . -name README.md -type f -print | xargs rm -f
    find . -name README.markdown -type f -print | xargs rm -f
    find . -name Readme.md -type f -print | xargs rm -f
    find . -name .npmignore -type f -print | xargs rm -f
    find . -name .travis.yml -type f -print | xargs rm -f
    find . -name LICENSE -type f -print | xargs rm -f
    find . -name LICENSE.txt -type f -print | xargs rm -f
    find . -name LICENCE -type f -print | xargs rm -f
    find . -name License -type f -print | xargs rm -f
    find . -name AUTHORS -type f -print | xargs rm -f
    find . -name CONTRIBUTING.md -type f -print | xargs rm -f

%install
    #   create installation hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/lib/node/pkg/java

    #   install package
    cp -rp node_modules/java/* \
        $RPM_BUILD_ROOT%{l_prefix}/lib/node/pkg/java/
    rm -rf node_modules/java
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/lib/node/pkg/java/node_modules
    cp -rp node_modules/* \
        $RPM_BUILD_ROOT%{l_prefix}/lib/node/pkg/java/node_modules/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

